routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;


Auth::routes();

//minimum user / logged in user
Route::group(['middleware' => ['level:1']], function () {
    //minimum Teacher
    Route::group(['middleware' => ['level:4']], function () {
        Route::group(['middleware' => ['level:5']], function () {
        });
        Route::resource('courses', 'CoursesController');
        Route::resource('courses.assignments', 'AssignmentController');
        Route::resource('courses.assignments.handin','HandinController', ['except' => ['store']]);
        Route::get('courses/{course}/assignments/{assignment}/handin/{handin}/download','HandinController@downloadhandin')->name('course.assignments.handin.download');
        Route::resource('users', 'UserController');

    });
    Route::resource('/', 'DashboardController');

    Route::resource('forum','ForumController',['except' => ['show']])->parameters(['forum' => 'category']);
    Route::resource('forum.topic','ForumTopicController')->parameters(['forum' => 'category']);
    Route::resource('forum.topic.post','ForumTopicPostController')->parameters(['forum' => 'category']);

    Route::resource('courses', 'CoursesController', ['only' => ['index']]);
    Route::resource('courses.assignments', 'AssignmentController', ['only' => ['index','show']]);
    Route::resource('courses.assignments.handin','HandinController', ['only' => ['create','store']]);

    Route::resource('profile', 'ProfileController');
    Route::resource('dashboard', 'DashboardController');


});

app/Assignment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Assignment extends Model
{
    public function course(){
        return $this->belongsTo(Course::class);
    }
}

app/Http/Controllers/AssignmentController.php
<?php

namespace App\Http\Controllers;

use App\Assignment;
use App\Course;
use App\Http\Requests\CreateAssignmentRequest;
use Illuminate\Http\Request;

class AssignmentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param Course $course
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index(Course $course)
    {
        return view('assignments.index', ['assignments' =>  $course->assignments, 'course' => $course]);
    }

    /**
     * Show the form for creating a new resource.
     *


     * @param Course $course
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View

     */
    public function create(Course $course)
    {
        return view('assignments.create', ['course' => $course]);
    }

    /**
     * Store a newly created resource in storage.
     *


     * @param CreateAssignmentRequest $request
     * @param Course $course
     * @return \Illuminate\Http\RedirectResponse


     */
    public function store(CreateAssignmentRequest $request, Course $course)
    {
        if (!$request->validated()) {
            return redirect()->back()->withInput($request->input())->withErrors($request);
        }
        $assignment = new Assignment();
        $assignment->course_id = $course->id;
        $assignment->name = $request['name'];
        $assignment->description = $request['description'];
        $assignment->save();
        return redirect()->route('courses.assignments.index',['course'=>$course->id]);
    }

    /**
     * Display the specified resource.
 * @param Course $course
     * @param \App\Assignment $assignment
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
 */

    public function show(Course $course ,Assignment $assignment)
    {
        return view('assignments.show', ['course' => $course, 'assignment' => $assignment]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param \App\Assignment $assignment
     * @return \Illuminate\Http\Response
     */
    public function edit(Assignment $assignment)
    {

    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param \App\Assignment $assignment
     * @param Course $course
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(CreateAssignmentRequest $request,Course $course, Assignment $assignment)
    {
        $assignment->name = $request['name'];
        $assignment->description = $request['description'];
        $assignment->save();
        return redirect()->route('courses.assignments.index',$course);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Course $course
     * @param Assignment $assignment
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Exception
     */
    public function destroy(Course $course,Assignment $assignment)
    {
        $assignment->delete();
        return redirect()->route('courses.assignments.index',['course'=>$course]);
    }
}

resources/views/assignments/create.blade.php
@extends('layouts.dashboard')
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.index',$course)}}">Courses</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.index',$course)}}">Assignments</a></li>
            <li class="breadcrumb-item active" aria-current="page">Create assignments</li>
        </ol>
    </nav>
    <div class="container-sm">
        <h1>New assignment</h1>
        {{ Form::open(array('route' => array('courses.assignments.store',$course),'method'=>'post','files'=>true)) }}
        <div class="form-group">
            {{ Form::label('name', 'Name') }}
            {{ Form::text('name',null,array('class'=>'form-control')) }}
            {{ Form::label('description', 'Description') }}
            {{ Form::textarea('description',null,array('class'=>'form-control')) }}
            @foreach($errors->all() as $error)
                <p class="text-danger">
                    {{ $error }}
                </p>
            @endforeach
        </div>
        {{Form::submit('Save',array('class'=>'btn btn-primary'))}}
        {{Form::close()}}
    </div>
@endsection

resources/views/assignments/index.blade.php
@extends('layouts.dashboard')
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.index',$course)}}">Courses</a></li>
            <li class="breadcrumb-item active" aria-current="page">Assignments</li>
        </ol>
    </nav>
    <div class="container-sm">
        <h1 class="display-6 ml-4 font-weight-bold text-xl-center text-center mb-5">Assignments</h1>
        @if(Auth::user()->hasRole('admin|teacher'))
            <a class="btn btn-success float-right" href="{{route('courses.assignments.create',$course)}}">Create
                assignment</a><br><br>
        @endif
        @foreach($assignments as $assignment)
            <ul class="list-group mt-3">
                @if ($assignment->count())
                    <li class="list-group-item border-0 mb-3 shadow-sm">
                        <span class="font-weight-light mt-4">{{$assignment->name}}</span>
                        <span><a class="btn btn-primary d-flex  justify-content-between float-right ml-2" href="{{route('courses.assignments.show',[$course,$assignment])}}">Go to Assignment</a>
                             @if(Auth::user()->hasRole('admin|teacher'))
                                <button class="btn btn-danger float-right" type="button" data-toggle="collapse" data-target="#multiCollapseExample{{$assignment->id}}" aria-expanded="false" aria-controls="multiCollapseExample{{$assignment->id}}">Edit</button>
                               <br><br>
                                <div class="collapse multi-collapse" id="multiCollapseExample{{$assignment->id}}">
                                    <div class="card card-body">
                                        <div class="row">
                                            <div class="col-sm-3"><form action="{{route('courses.assignments.destroy',[$course,$assignment->id])}}" method="post">@csrf @method('DELETE')<button type="submit" class="btn btn-danger float-left">Delete</button></form> </div>
                                            <form action="{{route('courses.assignments.update',[$course,$assignment->id])}}" class="form-inline" method="post">@csrf @method('PUT')
                                            <input type="text" name="name" value="{{$assignment->name}}" class="form-control mr-2" required>
                                            <input type="text" name="description" value="{{$assignment->description}}" class="form-control mr-2" required>
                                            <button type="submit" class="btn btn-primary float-left">Update</button>
                                            </form>
                                             @foreach($errors->all() as $error)
                                                <p class="text-danger">
                                                    {{ $error }}
                                                </p>
                                             @endforeach
                                        </div>
                                    </div>
                                </div>
                            @endif
                        </span>
                    </li>
                @else
                    <li class="list-group-item border-0 mb-3 shadow-sm">
                        There are no assignments available.
                    </li>
                @endif
            </ul>
        @endforeach
    </div>
@endsection

resources/views/assignments/show.blade.php
@extends('layouts.dashboard')
@section ('title', 'Assignments |' . $assignment->name)
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.index',$course)}}">Courses</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.index',$course)}}">Assignments</a></li>
            <li class="breadcrumb-item active" aria-current="page">Assignment overview</li>
        </ol>
    </nav>
    <div class="container">
        <div class="row">
            <div class="col-12 col-sm-10 col-lg-6 mx-auto">
                <h1 class="display-4" style="text-align: center; margin: 50px 0;">Assignment</h1>
                <div class="form-group py-3 px-4 shadow rounded">
                    <label for="title "><h4 class="font-weight-bold">Title:</h4></label>
                    <p>{{$assignment->name}}</p>
                    <label for="Description"><h4 class="font-weight-bold">Description:</h4></label>
                    <p>{{$assignment->description}}</p>
                    <div style="padding:40px 0px;">
                        <a class="btn btn-success float-right"
                           href="{{route('courses.assignments.handin.create',[$course,$assignment])}}">Handin
                            assignment</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection